package cz.cvut.ok.kapo.paa.kybl;


/**
 * Trida reprezentujici pouze naplneni jednotlivych kyblu.
 * @author karel
 *
 */
public class State implements Cloneable{
	private int[] kyble;
	
	public State(int k1, int k2, int k3, int k4, int k5) {
		super();
		this.kyble = new int[6];
		this.kyble[1]=k1;
		this.kyble[2]=k2;
		this.kyble[3]=k3;
		this.kyble[4]=k4;
		this.kyble[5]=k5;
	}

	/**
	 * @return Returns the k1.
	 */
	public int getK1() {
		return kyble[1];
	}

	/**
	 * @return Returns the k2.
	 */
	public int getK2() {
		return kyble[2];
	}

	/**
	 * @return Returns the k3.
	 */
	public int getK3() {
		return kyble[3];
	}

	/**
	 * @return Returns the k4.
	 */
	public int getK4() {
		return kyble[4];
	}

	/**
	 * @return Returns the k5.
	 */
	public int getK5() {
		return kyble[5];
	}

	/**
	 * Sets the k1.
	 */
	public void setK1(int amount) {
		kyble[1]=amount;
	}

	/**
	 * Sets the k2.
	 */
	public void setK2(int amount) {
		kyble[2]=amount;
	}

	/**
	 * Sets the k3.
	 */
	public void setK3(int amount) {
		kyble[3]=amount;
	}

	/**
	 * Sets the k4.
	 */
	public void setK4(int amount) {
		kyble[4]=amount;
	}

	/**
	 * Sets the k5.
	 */
	public void setK5(int amount) {
		kyble[5]=amount;
	}
	
	public int getKybl(int kybl){
		return this.kyble[kybl];
	}
	
	public void setKybl(int kybl, int amount){
		this.kyble[kybl]=amount;
	}
	
	/**
	 * Vytvori klon objektu a vrati ho.
	 */
	@Override
	public State clone(){
		return new State(getK1(),getK2(),getK3(),getK4(),getK5());
	}
	
	/**
	 * Vypise strucne strukturu stavu.
	 */
	@Override
	public String toString(){
		return "["+getK1()+","+getK2()+","+getK3()+","+getK4()+","+getK5()+"]";
	}
	
	/**
	 * Srovnavaci metoda.
	 */
	@Override
	public boolean equals(Object o){
		State obj = (State)o;
		for (int i=1;i<=5;i++)
			if (getKybl(i)!=obj.getKybl(i))
				return false;
		return true;
	}
}
