package cz.cvut.ok.kapo.paa.kybl.utils;

import java.util.Collection;
import java.util.LinkedList;

public class MyLinkedList<E> extends LinkedList<E> implements MyQueue<E> {
	private static final long serialVersionUID = 2570141694954513670L;

	private int inserts, removes;

	public MyLinkedList() {
		super();
		this.inserts=0;
		this.removes=0;
	}

	public MyLinkedList(Collection<E> arg0) {
		super(arg0);
		this.inserts=0;
		this.removes=0;
	}

//	 ============================= nove metody =================
		/* (non-Javadoc)
		 * @see cz.cvut.ok.kapo.paa.kybl.utils.MyQueue#getInserts()
		 */
		public int getInserts() {
			return inserts;
		}

		/* (non-Javadoc)
		 * @see cz.cvut.ok.kapo.paa.kybl.utils.MyQueue#getRemoves()
		 */
		public int getRemoves() {
			return removes;
		}
//		 ================ pretizeni metod ========================


		/* (non-Javadoc)
		 * @see java.util.PriorityQueue#add(E)
		 */
		@Override
		public boolean add(E arg0) {
			this.inserts++;
			return super.add(arg0);
		}

		/* (non-Javadoc)
		 * @see java.util.PriorityQueue#offer(E)
		 */
		@Override
		public boolean offer(E arg0) {
			this.inserts++;
			return super.offer(arg0);
		}

		/* (non-Javadoc)
		 * @see java.util.PriorityQueue#poll()
		 */
		@Override
		public E poll() {
			this.removes++;
			return super.poll();
		}

		/* (non-Javadoc)
		 * @see java.util.PriorityQueue#remove(java.lang.Object)
		 */
		@Override
		public boolean remove(Object arg0) {
			this.removes++;
			return super.remove(arg0);
		}
		
		

}
