package cz.cvut.ok.kapo.paa.kybl;


public class Configuration {
	private State start, end, capacities;
	
	/**
	 * k1 - k5 oznacuje kapacitu jednotlivych kyblu.
	 */
	public Configuration(int k1, int k2, int k3, int k4, int k5) {
		super();
		this.capacities = new State(k1,k2,k3,k4,k5);
		this.end = null;
		this.start = null;
	}
	
	/**
	 * Nastavi koncovy stav v kyblech.
	 * k1 - k5 oznacuje koncovy stav v kyblech.
	 */
	public void setEndState(int k1, int k2, int k3, int k4, int k5){
		this.end = new State(k1,k2,k3,k4,k5);
	}
	
	/**
	 * @param startState The startState to set.
	 */
	public void setStartState(int k1, int k2, int k3, int k4, int k5) {
		this.start = new State(k1,k2,k3,k4,k5);
	}

	/**
	 * @return Returns the endState.
	 */
	public State getEndState() {
		return end;
	}

	/**
	 * @return Returns the startState.
	 */
	public State getStartState() {
		return start;
	}

	/**
	 * @return Returns the capacities.
	 */
	public State getCapacities() {
		return capacities;
	}

}
