package cz.cvut.ok.kapo.paa.kybl;

import java.util.List;

import junit.framework.TestCase;

public class NodeTest extends TestCase {

	/*
	 * Test method for 'cz.cvut.ok.kapo.paa.kybl.engines.bfs.Node.getPath()'
	 */
	public void testGetPath() {
		Node root=new Node();
		Node n1=new Node();
		Node n2=new Node();
		
		n1.setParent(root);
		n2.setParent(n1);
		
		assertEquals(2, n2.getLength());
		assertEquals(3, n2.getPath().size());
		
		List l = n2.getPath();
		assertEquals(0, l.indexOf(root));

		l = n1.getPath();
		assertEquals(0, l.indexOf(root));
	}

}
