package cz.cvut.ok.kapo.paa.kybl;

/**
 * Obsahuje pouze konstanty pro kody operaci.
 * @author karel
 */
public class OpCodes {
	public final static int OC_NONE = 0;
	public final static int OC_FILL = 1;
	public final static int OC_EMPTY= 2;
	public final static int OC_POUR = 3; // 1. src, 2. dst
	
	public OpCodes() {
		super();
	}

	/**
	 * Vrati string operace podle jejiho kodu.
	 * @param opcode
	 * @return
	 */
	public static String getOpName(int opcode){
		switch(opcode){
			case OpCodes.OC_NONE: return "NONE";
			case OpCodes.OC_FILL: return "FILL";
			case OpCodes.OC_EMPTY: return "EMPTY";
			case OpCodes.OC_POUR: return "POUR";
			default: break;	
		}
		return "UNKNOWN";
	}
	
}
